
jQuery( function ( $ ) {

    var FPAdminScripts = {
        init : function () {
            jQuery( '.gif_rs_sumo_reward_button_for_unsubscribe' ).css( 'display' , 'none' ) ;
            $( document ).on( 'click' , '.rs_add_rule_for_custom_reg_field' , this.append_rule_for_cus_reg_field ) ;
            $( document ).on( 'click' , '.rs_remove_rule_for_custom_reg_field' , this.remove_rule_for_cus_reg_field ) ;
            $( document ).on( 'change' , '.rs_search_custom_field' , this.get_selected_field_type ) ;
            $( document ).on( 'click' , '#rs_enable_reward_program' , this.save_reward_program_disable_option ) ;
            $( document ).on( 'change' , '#changepagesizertemplates' , this.pagination_for_templates ) ;
            $( 'body' ).on( 'blur' , adminscripts_params.field_ids , this.validation_in_product_settings_on_blur ) ;
            $( 'body' ).on( 'keyup change' , adminscripts_params.field_ids , this.validation_in_product_settings_on_keyup ) ;
            $( 'body' ).on( 'click' , 'body' , this.validation_in_product_settings_on_body_click ) ;
        } ,
        pagination_for_templates : function ( e ) {
            e.preventDefault() ;
            var pageSize = jQuery( this ).val() ;
            jQuery( '.footable' ).data( 'page-size' , pageSize ) ;
            jQuery( '.footable' ).trigger( 'footable_initialized' ) ;
        } ,
        validation_in_product_settings_on_blur : function () {
            $( '.wc_error_tip' ).fadeOut( '100' , function () {
                $( this ).remove() ;
            } ) ;
            return this ;
        } ,
        validation_in_product_settings_on_keyup : function () {
            var value = $( this ).val() ;
            var regex = new RegExp( "[^\+0-9\%.\\" + woocommerce_admin.mon_decimal_point + "]+" , "gi" ) ;
            var newvalue = value.replace( regex , '' ) ;

            if ( value !== newvalue ) {
                $( this ).val( newvalue ) ;
                if ( $( this ).parent().find( '.wc_error_tip' ).size() == 0 ) {
                    $( this ).after( '<div class="wc_error_tip">' + woocommerce_admin.i18n_mon_decimal_error + " Negative Values are not allowed" + '</div>' ) ;
                    $( '.wc_error_tip' )
                            .css( 'left' , offset.left + $( this ).width() - ( $( this ).width() / 2 ) - ( $( '.wc_error_tip' ).width() / 2 ) )
                            .css( 'top' , offset.top + $( this ).height() )
                            .fadeIn( '100' ) ;
                }
            }
            return this ;
        } ,
        validation_in_product_settings_on_body_click : function () {
            $( '.wc_error_tip' ).fadeOut( '100' , function () {
                $( this ).remove() ;
            } ) ;
            return this ;
        } ,
        save_reward_program_disable_option : function () {
            if ( jQuery( '#rs_enable_reward_program' ).is( ':checked' ) == false ) {
                if ( confirm( 'Are you sure you want to turn off this option? Please note, If You Turn Off this option ,then all the users on your site will be in part of SUMO Reward Points)' ) ) {
                    return true ;
                }
                return false ;
            }
        } ,
        append_rule_for_cus_reg_field : function ( event ) {
            event.preventDefault() ;
            FPAdminScripts.block( '.rs_rule_for_custom_reg_field' ) ;
            var count = parseInt( $( 'input#rs_rule_id_for_custom_reg_field:last' ).val() ) ;
            count = count + 1 || 0 ;
            var data = {
                action : 'rs_add_rule_for_cus_reg_fields' ,
                count : count ,
                sumo_security : adminscripts_params.rs_rule_for_cus_reg_fields
            } ;
            $.post( adminscripts_params.ajaxurl , data , function ( response ) {
                if ( true === response.success ) {
                    $( '#rs_append_rule_for_custom_reg_field' ).append( response.data.content ) ;
                    FPAdminScripts.unblock( '.rs_rule_for_custom_reg_field' ) ;
                    jQuery( 'body' ).trigger( 'wc-enhanced-select-init' ) ;
                } else {
                    window.alert( response.data.error ) ;
                    FPAdminScripts.unblock( '.rs_rule_for_custom_reg_field' ) ;
                }
            } ) ;
        } ,
        get_selected_field_type : function ( event ) {
            event.preventDefault() ;
            var $this = $( event.currentTarget ) ;
            var count = $( $this ).closest( 'tr' ).find( '#rs_rule_id_for_custom_reg_field' ).val() ;
            var key = count + 1 || 0 ;
            var data = {
                action : 'rs_get_cus_field_type' ,
                field_id : $( $this ).val() ,
            } ;
            $.post( adminscripts_params.ajaxurl , data , function ( response ) {
                if ( true === response.success ) {
                    $( $this ).closest( 'tr' ).find( '.rs_label_for_cus_field_type' ).html( response.data.content ) ;
                    $( $this ).closest( 'tr' ).find( '.rs_label_for_cus_field_type_hidden' ).val( response.data.content ) ;
                    if ( response.data.content == 'DATEPICKER' ) {
                        $( $this ).closest( 'tr' ).find( '.rs_label_for_datepicker_type' ).html( '<select style="width:50% !important;" name="rs_rule_for_custom_reg_field[' + key + '][repeat_points]"><option value="no">No</option><option value="yes">Yes</option></select>' ) ;
                        $( $this ).closest( 'tr' ).find( '.rs_label_award_points_for_filling_datepicker' ).html( '<input type="checkbox" name="rs_rule_for_custom_reg_field[' + key + '][award_points_for_filling]"/>' ) ;
                    } else {
                        $( $this ).closest( 'tr' ).find( '.rs_label_for_datepicker_type' ).html( 'N/A' ) ;
                        $( $this ).closest( 'tr' ).find( '.rs_label_award_points_for_filling_datepicker' ).html( 'N/A' ) ;
                    }
                } else {
                    window.alert( response.data.error ) ;
                    FPAdminScripts.unblock( '.rs_rule_for_custom_reg_field' ) ;
                }
            } ) ;
        } ,
        remove_rule_for_cus_reg_field : function ( event ) {
            event.preventDefault() ;
            var $this = $( event.currentTarget ) ;
            $( $this ).parent().parent().remove() ;
        } ,
        block : function ( id ) {
            $( id ).block( {
                message : null ,
                overlayCSS : {
                    background : '#fff' ,
                    opacity : 0.6
                }
            } ) ;
        } ,
        unblock : function ( id ) {
            $( id ).unblock() ;
        } ,
    } ;
    FPAdminScripts.init() ;
} ) ;