<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit ; // Exit if accessed directly.
}

if ( ! class_exists( 'RSFunctionForMessage' ) ) {

    class RSFunctionForMessage {

        public static function init() {
            if ( get_option( 'rs_reward_table_position' ) == '1' ) {
                add_action( 'woocommerce_after_my_account' , array( __CLASS__ , 'reward_log' ) ) ;
            } else {
                add_action( 'woocommerce_before_my_account' , array( __CLASS__ , 'reward_log' ) ) ;
            }
        }

        public static function reward_log() {
            if ( get_option( 'rs_reward_content' ) != 'yes' )
                return ;

            if ( get_option( 'rs_my_reward_table' ) == 2 )
                return ;
            ?>
            <style type="text/css">
            <?php echo get_option( 'rs_myaccount_custom_css' ) ; ?>
            </style>
            <?php
            $TableData = array(
                'points_log_sort'        => get_option( 'rs_points_log_sorting' ) ,
                'search_box'             => get_option( 'rs_show_hide_search_box_in_my_rewards_table' ) ,
                'page_size'              => get_option( 'rs_show_hide_page_size_my_rewards' ) ,
                'points_label_position'  => get_option( 'rs_reward_point_label_position' ) ,
                'total_points_label'     => get_option( 'rs_my_rewards_total' ) ,
                'display_currency_value' => get_option( 'rs_reward_currency_value' ) ,
                'sno'                    => get_option( 'rs_my_reward_points_s_no' ) ,
                'points_expiry'          => get_option( 'rs_my_reward_points_expire' ) ,
                'username'               => get_option( 'rs_my_reward_points_user_name_hide' ) ,
                'reward_for'             => get_option( 'rs_my_reward_points_reward_for_hide' ) ,
                'earned_points'          => get_option( 'rs_my_reward_points_earned_points_hide' ) ,
                'redeemed_points'        => get_option( 'rs_my_reward_points_redeemed_points_hide' ) ,
                'total_points'           => get_option( 'rs_my_reward_points_total_points_hide' ) ,
                'earned_date'            => get_option( 'rs_my_reward_points_earned_date_hide' ) ,
                'my_reward_label'        => get_option( 'rs_my_rewards_title' ) ,
                'label_sno'              => get_option( 'rs_my_rewards_sno_label' ) ,
                'label_username'         => get_option( 'rs_my_rewards_userid_label' ) ,
                'label_reward_for'       => get_option( 'rs_my_rewards_reward_for_label' ) ,
                'label_earned_points'    => get_option( 'rs_my_rewards_points_earned_label' ) ,
                'label_redeemed_points'  => get_option( 'rs_my_rewards_redeem_points_label' ) ,
                'label_total_points'     => get_option( 'rs_my_rewards_total_points_label' ) ,
                'label_earned_date'      => get_option( 'rs_my_rewards_date_label' ) ,
                'label_points_expiry'    => get_option( 'rs_my_rewards_points_expired_label' ) ,
                    ) ;
            self::reward_log_table( $TableData ) ;
        }

        public static function reward_log_table( $TableData ) {
            ob_start() ;
            $UserId  = get_current_user_id() ;
            $BanType = check_banning_type( $UserId ) ;
            if ( $BanType == 'redeemingonly' || $BanType == 'both' )
                return ;

            global $wpdb ;
            $LogTable = $wpdb->prefix . 'rsrecordpoints' ;
            $UserLog  = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM $LogTable WHERE userid = %d AND showuserlog = false" , $UserId ) , ARRAY_A ) ;
            $UserLog  = $UserLog + ( array ) get_user_meta( $UserId , '_my_points_log' , true ) ;
            if ( ! srp_check_is_array( $UserLog ) )
                return ;

            echo "<h2  class=my_rewards_title>" . $TableData[ 'my_reward_label' ] . "</h2>" ;
            $PointData       = new RS_Points_Data( $UserId ) ;
            $AvailablePoints = $PointData->total_available_points() ;
            $DisplayCurrency = $TableData[ 'display_currency_value' ] ;
            if ( $DisplayCurrency == '1' ) {
                $msg = '(' . $PointData->total_available_points_as_currency() . ')' ;
            } else {
                $msg = '' ;
            }
            if ( $TableData[ 'points_label_position' ] == '1' ) {
                echo "<h4 class=my_reward_total> " . $TableData[ 'total_points_label' ] . " " . $AvailablePoints . " " . $msg . "</h4><br>" ;
            } else {
                echo "<h4 class=my_reward_total> " . $AvailablePoints . " " . $msg . $TableData[ 'total_points_label' ] . "</h4><br>" ;
            }

            $outputtablefields = '<p> ' ;
            if ( $TableData[ 'search_box' ] == '1' )
                $outputtablefields .= __( 'Search:' , SRP_LOCALE ) . '<input id="filters" type="text"/> ' ;

            if ( $TableData[ 'page_size' ] == '1' ) {
                $outputtablefields .= __( 'Page Size:' , SRP_LOCALE ) . '<select id="change-page-sizes"><option value="5">5</option><option value="10">10</option><option value="50">50</option>
                    <option value="100">100</option>
                </select>' ;
            }
            $outputtablefields .= '</p>' ;
            echo ( $TableData[ 'search_box' ] == '2' && $TableData[ 'page_size' ] == '2' ) ? '' : $outputtablefields ;
            $DefaultColumn     = array(
                'username' ,
                'reward_for' ,
                'earned_points' ,
                'redeemed_points' ,
                'points_expiry' ,
                'total_points' ,
                'earned_date' ,
                    ) ;
            $SortedColumn      = srp_check_is_array( get_option( 'sorted_settings_list' ) ) ? get_option( 'sorted_settings_list' ) : $DefaultColumn ;
            ?>
            <table class = "my_reward_table demo shop_table my_account_orders table-bordered" data-filter = "#filters" data-page-size="5" data-page-previous-text = "prev" data-filter-text-only = "true" data-page-next-text = "next">
                <thead>
                    <tr>
                        <th data-toggle=true data-sort-initial =true ><?php echo $TableData[ "label_sno" ] ; ?></th>
                        <?php
                        $i                 = 1 ;
                        foreach ( $SortedColumn as $Column ) {
                            if ( $TableData[ $Column ] == '1' ) {
                                $data_hide = $i > 2 ? 'phone,tablet' : '' ;
                                ?>
                                <th data-hide="<?php echo $data_hide ; ?>"><?php echo $TableData[ "label_$Column" ] ; ?></th>
                                <?php
                                $i ++ ;
                            }
                        }
                        ?>
                    </tr>
                </thead>
                <tbody>
                    <?php
                    if ( $TableData[ 'points_log_sort' ] == '1' )
                        krsort( $UserLog , SORT_NUMERIC ) ;

                    $i = 1 ;
                    foreach ( $UserLog as $Log ) {
                        if ( ! srp_check_is_array( $Log ) )
                            continue ;

                        $CheckPoint = $Log[ 'checkpoints' ] ;
                        if ( isset( $Log[ 'earnedpoints' ] ) && ! empty( $Log[ 'checkpoints' ] ) ) {
                            $Points         = empty( $Log[ 'earnedpoints' ] ) ? 0 : round_off_type( $Log[ 'earnedpoints' ] ) ;
                            $RedeemedPoints = empty( $Log[ 'redeempoints' ] ) ? 0 : (get_option( 'rs_enable_round_off_type_for_calculation' ) == 'yes') ? $Log[ 'redeempoints' ] : round_off_type( $Log[ 'redeempoints' ] ) ;
                            $TotalPoints    = empty( $Log[ 'totalpoints' ] ) ? 0 : round_off_type( $Log[ 'totalpoints' ] ) ;
                            $Username       = get_user_meta( $Log[ 'userid' ] , 'nickname' , true ) ;
                            $RefUsername    = get_user_meta( $Log[ 'refuserid' ] , 'nickname' , true ) ;
                            $NomineeName    = get_user_meta( $Log[ 'nomineeid' ] , 'nickname' , true ) ;
                            $Reason         = RSPointExpiry::msg_for_log( false , true , true , $Log[ 'earnedpoints' ] , $CheckPoint , $Log[ 'productid' ] , $Log[ 'orderid' ] , $Log[ 'variationid' ] , $Log[ 'userid' ] , $RefUsername , $Log[ 'reasonindetail' ] , $Log[ 'redeempoints' ] , false , $NomineeName , $Username , $Log[ 'nomineepoints' ] ) ;
                        } else {
                            $Points         = empty( $Log[ 'points_earned_order' ] ) ? 0 : round_off_type( $Log[ 'points_earned_order' ] ) ;
                            $RedeemedPoints = empty( $Log[ 'points_redeemed' ] ) ? 0 : (get_option( 'rs_enable_round_off_type_for_calculation' ) == 'yes') ? $Log[ 'points_redeemed' ] : round_off_type( $Log[ 'points_redeemed' ] ) ;
                            $TotalPoints    = empty( $Log[ 'totalpoints' ] ) ? 0 : round_off_type( $Log[ 'totalpoints' ] ) ;
                            $Reason         = empty( $Log[ 'rewarder_for_frontend' ] ) ? 0 : $Log[ 'rewarder_for_frontend' ] ;
                        }
                        $DateFormat = (get_option( 'rs_dispaly_time_format' ) == '1') ? "d-m-Y h:i:s A" : get_option( 'date_format' ) . ' ' . get_option( 'time_format' ) ;

                        if ( $CheckPoint == 'IMPOVR' || $CheckPoint == 'IMPADD' ) {
                            $GMTExpDate = $Log[ 'expirydate' ] + get_option( 'gmt_offset' ) * HOUR_IN_SECONDS ;
                            $ExpDate    = $Log[ 'expirydate' ] != 999999999999 ? date_i18n( $DateFormat , ( float ) $GMTExpDate ) : '-' ;
                        } else {
                            $ExpDate = $Log[ 'expirydate' ] != 999999999999 ? date_i18n( $DateFormat , ( float ) $Log[ 'expirydate' ] ) : '-' ;
                        }
                        $ExpDate = ($ExpDate != '-') ? strftime( $ExpDate ) : '-' ;

                        if ( (($Points != 0) && ($RedeemedPoints != 0)) || ((($Points != 0) && ($RedeemedPoints == 0)) || (($Points == 0) && ($RedeemedPoints != 0))) || ( ! empty( $Reason )) ) {
                            $GMTEarnedDate       = $Log[ 'earneddate' ] + get_option( 'gmt_offset' ) * HOUR_IN_SECONDS ;
                            $EarnedDate          = is_numeric( $Log[ 'earneddate' ] ) ? date_i18n( $DateFormat , $GMTEarnedDate ) : $Log[ 'earneddate' ] ;
                            $EarnedDate          = strftime( $EarnedDate ) ;
                            $DefaultColumnValues = array(
                                'sno'             => $i ,
                                'points_expiry'   => $ExpDate ,
                                'username'        => $Username ,
                                'reward_for'      => $Reason ,
                                'earned_points'   => $Points ,
                                'redeemed_points' => $RedeemedPoints ,
                                'total_points'    => $TotalPoints ,
                                'earned_date'     => $EarnedDate ,
                                    ) ;
                            ?>
                            <tr>
                                <td data-value="<?php echo $DefaultColumnValues[ 'sno' ] ; ?>"><?php echo $DefaultColumnValues[ 'sno' ] ; ?></td>
                                <?php
                                foreach ( $SortedColumn as $Column ) {
                                    if ( $TableData[ $Column ] == '1' ) {
                                        ?>
                                        <td><?php echo $DefaultColumnValues[ $Column ] ; ?></td>
                                        <?php
                                    }
                                }
                                ?>
                            </tr>
                            <?php
                        }
                        $i ++ ;
                    }
                    ?>
                </tbody>
                <tfoot>
                    <tr style="clear:both;">
                        <td colspan="7">
                            <div class="pagination pagination-centered"></div>
                        </td>
                    </tr>
                </tfoot>
            </table>
            <?php
            return ob_get_contents() ;
        }

    }

    RSFunctionForMessage::init() ;
}
