<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit ; // Exit if accessed directly.
}
if ( ! class_exists( 'RSDiscountCompatability' ) ) {

    class RSDiscountCompatability {

        public static function init() {
            add_action( 'woocommerce_before_checkout_form' , array( __CLASS__ , 'display_msg_when_discounts_applied' ) ) ;
            if ( get_option( 'rs_reward_point_troubleshoot_before_cart' ) == '1' ) {
                if ( get_option( 'rs_message_before_after_cart_table' ) == '1' ) {
                    add_action( 'woocommerce_before_cart' , array( __CLASS__ , 'display_msg_when_discounts_applied' ) ) ;
                } else {
                    add_action( 'woocommerce_after_cart_table' , array( __CLASS__ , 'display_msg_when_discounts_applied' ) ) ;
                }
            } else {
                if ( get_option( 'rs_message_before_after_cart_table' ) == '1' ) {
                    add_action( 'woocommerce_before_cart_table' , array( __CLASS__ , 'display_msg_when_discounts_applied' ) ) ;
                } else {
                    add_action( 'woocommerce_after_cart_table' , array( __CLASS__ , 'display_msg_when_discounts_applied' ) ) ;
                }
            }
        }

        public static function display_msg_when_discounts_applied() {
            if ( ! class_exists( 'SUMODiscounts' ) )
                return ;

            if ( ! check_if_discount_applied() )
                return ;

            if ( get_option( '_rs_show_hide_coupon_if_sumo_discount' ) != 'yes' )
                return ;
            ?>
            <div class="woocommerce-info rs_show_notice_for_hide_redeem_field">
                <?php echo get_option( 'rs_message_in_cart_and_checkout_for_discount' ) ; ?>
            </div>
            <?php
        }

    }

    RSDiscountCompatability::init() ;
}